//+------------------------------------------------------------------+
//|                                               getTimeScalePx.mq4 |
//|                                                            Erics |
//|                                                  erics.fx@tut.by |
//+------------------------------------------------------------------+
#property copyright "Erics"
#property link      "erics.fx@tut.by"

#import "user32.dll"
  bool GetWindowRect(int h, int& pos[4]);
#import

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start()
{
  int px = getTimeScalePx(); //  1, 2, 4, 8, 16, 32  -1 ( )
  MessageBox(" , : " + px);
  Print(" , : " + px);
  if(px>0)
  Print("  : ", MathRound(MathLog(px)/MathLog(2.))); //   (0-5)
}
//+------------------------------------------------------------------+

int getTimeScalePx()
{
  int h = WindowHandle(Symbol(), Period());
  int rect[4];
  if(h==0) return(-1);
  GetWindowRect(h, rect);
  int wW  = rect[2] - rect[0]; //  
  int bpc = WindowBarsPerChart();
  if(bpc==0) return(-1);
  return(MathFloor((wW-48)/bpc));
}